[exim-cvs] build: try to get dash/bash for sanity

Top Page
Delete this message
Reply to this message
Author: Exim Git Commits Mailing List
Date:  
To: exim-cvs
Subject: [exim-cvs] build: try to get dash/bash for sanity
Gitweb: http://git.exim.org/exim.git/commitdiff/5c7706b0c39a7cbb031f1d86594b41e0c96008fa
Commit:     5c7706b0c39a7cbb031f1d86594b41e0c96008fa
Parent:     a4ca1b01d4376f9b9ca7e06acf4eb7d164a38d2b
Author:     Phil Pennock <pdp@???>
AuthorDate: Wed Nov 20 17:16:02 2013 -0800
Committer:  Phil Pennock <pdp@???>
CommitDate: Wed Nov 20 17:16:02 2013 -0800


    build: try to get dash/bash for sanity


    The "local" builtin is not part of POSIX.  We want it.  Try harder to
    get a vaguely sane shell, rather than just a POSIX shell.


    Also, safeguard to error out more gracefully if invoked from outside the
    build process.
---
 src/scripts/lookups-Makefile | 26 ++++++++++++++++++++++++++
 1 file changed, 26 insertions(+)


diff --git a/src/scripts/lookups-Makefile b/src/scripts/lookups-Makefile
index d2caf70..61493c6 100755
--- a/src/scripts/lookups-Makefile
+++ b/src/scripts/lookups-Makefile
@@ -24,6 +24,22 @@ then
_XPG=1
export _XPG

+  # We need the _right_ tr, so must do that first; but if a shell which
+  # we're more confident is sane is available, let's try that.  Mostly,
+  # the problem is that "local" is not actually in "the" standard, it's
+  # just in every not-insane shell.  Though arguably, there are no shells
+  # with POSIX-ish syntax which qualify as "not insane".
+  for b in /bin/dash /bin/bash /usr/local/bin/bash
+  do
+    if [ -x "$b" ]
+    then
+      SHELL="$b"
+      break
+    fi
+  done
+  # if we get a report of a system with zsh but not bash, we can add that
+  # to the list, but be sure to enable sh_word_split in that case.
+
   exec "$SHELL" "$0" "$@"
 fi


@@ -41,6 +57,16 @@ tab='    '
 LC_ALL=C
 export LC_ALL


+if [ -f "$defs_source" ]
+then
+ :
+ # we are happy
+else
+ echo >&2 "$0: ERROR: MISSING FILE '${defs_source}'"
+ echo >&2 "$0: SHOULD HAVE BEEN CALLED FROM scripts/Configure-Makefile"
+ exit 1
+fi
+
# nb: do not permit leading whitespace for this, as CFLAGS_DYNAMIC is exported
# to the lookups subdir via a line with leading whitespace which otherwise
# matches